
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProductsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.create(
            {
                id: data.id || undefined,
        
        product_name: data.product_name
        ||
        null
            ,
            
        sku: data.sku
        ||
        null
            ,
            
        barcode: data.barcode
        ||
        null
            ,
            
        product_type: data.product_type
        ||
        null
            ,
            
        unit_of_measure: data.unit_of_measure
        ||
        null
            ,
            
        tax_rate: data.tax_rate
        ||
        null
            ,
            
        default_cost: data.default_cost
        ||
        null
            ,
            
        default_price: data.default_price
        ||
        null
            ,
            
        minimum_price: data.minimum_price
        ||
        null
            ,
            
        is_taxable: data.is_taxable
        ||
        false
        
            ,
            
        track_batch: data.track_batch
        ||
        false
        
            ,
            
        track_expiry: data.track_expiry
        ||
        false
        
            ,
            
        reorder_level: data.reorder_level
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await products.setCategory( data.category || null, {
            transaction,
        });
        
        await products.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'product_images',
                belongsToId: products.id,
            },
            data.product_images,
            options,
        );
        

        return products;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const productsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                product_name: item.product_name
            ||
            null
            ,
            
                sku: item.sku
            ||
            null
            ,
            
                barcode: item.barcode
            ||
            null
            ,
            
                product_type: item.product_type
            ||
            null
            ,
            
                unit_of_measure: item.unit_of_measure
            ||
            null
            ,
            
                tax_rate: item.tax_rate
            ||
            null
            ,
            
                default_cost: item.default_cost
            ||
            null
            ,
            
                default_price: item.default_price
            ||
            null
            ,
            
                minimum_price: item.minimum_price
            ||
            null
            ,
            
                is_taxable: item.is_taxable
            ||
            false
        
            ,
            
                track_batch: item.track_batch
            ||
            false
        
            ,
            
                track_expiry: item.track_expiry
            ||
            false
        
            ,
            
                reorder_level: item.reorder_level
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const products = await db.products.bulkCreate(productsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < products.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.products.getTableName(),
                    belongsToColumn: 'product_images',
                    belongsToId: products[i].id,
                },
                data[i].product_images,
                options,
            );
        }
        

        return products;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const products = await db.products.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.product_name !== undefined) updatePayload.product_name = data.product_name;
        
        
        if (data.sku !== undefined) updatePayload.sku = data.sku;
        
        
        if (data.barcode !== undefined) updatePayload.barcode = data.barcode;
        
        
        if (data.product_type !== undefined) updatePayload.product_type = data.product_type;
        
        
        if (data.unit_of_measure !== undefined) updatePayload.unit_of_measure = data.unit_of_measure;
        
        
        if (data.tax_rate !== undefined) updatePayload.tax_rate = data.tax_rate;
        
        
        if (data.default_cost !== undefined) updatePayload.default_cost = data.default_cost;
        
        
        if (data.default_price !== undefined) updatePayload.default_price = data.default_price;
        
        
        if (data.minimum_price !== undefined) updatePayload.minimum_price = data.minimum_price;
        
        
        if (data.is_taxable !== undefined) updatePayload.is_taxable = data.is_taxable;
        
        
        if (data.track_batch !== undefined) updatePayload.track_batch = data.track_batch;
        
        
        if (data.track_expiry !== undefined) updatePayload.track_expiry = data.track_expiry;
        
        
        if (data.reorder_level !== undefined) updatePayload.reorder_level = data.reorder_level;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await products.update(updatePayload, {transaction});

        
        
        if (data.category !== undefined) {
            await products.setCategory(
              
              data.category,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await products.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'product_images',
                belongsToId: products.id,
            },
            data.product_images,
            options,
        );
        

        return products;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of products) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of products) {
                await record.destroy({transaction});
            }
        });


        return products;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findByPk(id, options);

        await products.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await products.destroy({
            transaction
        });

        return products;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findOne(
            { where },
            { transaction },
        );

        if (!products) {
            return products;
        }

        const output = products.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        output.price_list_items_product = await products.getPrice_list_items_product({
            transaction
        });
        
        
        
        output.inventory_batches_product = await products.getInventory_batches_product({
            transaction
        });
        
        
        output.inventory_transactions_product = await products.getInventory_transactions_product({
            transaction
        });
        
        
        
        output.stock_adjustment_lines_product = await products.getStock_adjustment_lines_product({
            transaction
        });
        
        
        
        output.transfer_lines_product = await products.getTransfer_lines_product({
            transaction
        });
        
        
        
        output.supplier_products_product = await products.getSupplier_products_product({
            transaction
        });
        
        
        
        output.purchase_order_lines_product = await products.getPurchase_order_lines_product({
            transaction
        });
        
        
        
        output.goods_receipt_lines_product = await products.getGoods_receipt_lines_product({
            transaction
        });
        
        
        
        
        
        
        
        
        output.sale_lines_product = await products.getSale_lines_product({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.ai_reorder_suggestions_product = await products.getAi_reorder_suggestions_product({
            transaction
        });
        
        
        
        output.category = await products.getCategory({
            transaction
        });
        
        
        output.product_images = await products.getProduct_images({
            transaction
        });
        
        
        output.organizations = await products.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.product_categories,
        as: 'category',
        
        where: filter.category ? {
          [Op.or]: [
            { id: { [Op.in]: filter.category.split('|').map(term => Utils.uuid(term)) } },
            {
              category_name: {
                [Op.or]: filter.category.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'product_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.product_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'product_name',
                        filter.product_name,
                    ),
                };
            }
            
            if (filter.sku) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'sku',
                        filter.sku,
                    ),
                };
            }
            
            if (filter.barcode) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'barcode',
                        filter.barcode,
                    ),
                };
            }
            
            if (filter.unit_of_measure) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'unit_of_measure',
                        filter.unit_of_measure,
                    ),
                };
            }
            

            
            

            
            if (filter.tax_rateRange) {
                const [start, end] = filter.tax_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tax_rate: {
                    ...where.tax_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tax_rate: {
                    ...where.tax_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.default_costRange) {
                const [start, end] = filter.default_costRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    default_cost: {
                    ...where.default_cost,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    default_cost: {
                    ...where.default_cost,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.default_priceRange) {
                const [start, end] = filter.default_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    default_price: {
                    ...where.default_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    default_price: {
                    ...where.default_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.minimum_priceRange) {
                const [start, end] = filter.minimum_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    minimum_price: {
                    ...where.minimum_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    minimum_price: {
                    ...where.minimum_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reorder_levelRange) {
                const [start, end] = filter.reorder_levelRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.product_type) {
                where = {
                    ...where,
                product_type: filter.product_type,
            };
            }
            
            if (filter.is_taxable) {
                where = {
                    ...where,
                is_taxable: filter.is_taxable,
            };
            }
            
            if (filter.track_batch) {
                where = {
                    ...where,
                track_batch: filter.track_batch,
            };
            }
            
            if (filter.track_expiry) {
                where = {
                    ...where,
                track_expiry: filter.track_expiry,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.products.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'products',
                        'product_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.products.findAll({
            attributes: [ 'id', 'product_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['product_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.product_name,
        }));
    }

    
};

